#include<iostream>
#include<cstring>
#include<algorithm>
#include<cassert>
#include<cstdio>
#define unlikely(x)     __builtin_expect(!!(x), 0)
struct char_reader
{
	FILE* f; char *buf,*p1,*p2; int size;
	char_reader(FILE* fin,int bufsize=1<<16) { f=fin; size=bufsize; p1=p2=0; buf=new char[size]; }
	~char_reader() { delete []buf; }
	inline int operator()() { return p1==p2&&(p2=(p1=buf)+fread(buf,1,size,f),p1==p2)?EOF:*p1++; }
};
struct char_writer
{
	FILE* f; char *buf,*p,*end; int size;
	char_writer(FILE* fout,int bufsize=1<<16) { f=fout; size=bufsize; buf=new char[size]; p=buf; end=buf+bufsize; }
	~char_writer() { fwrite(buf,p-buf,1,f); delete []buf; }
	inline char operator()(char ch)
	{
		if(unlikely(end==p)) { fwrite(buf,end-buf,1,f); p=buf; }
		return *p++=ch;
	}
};
char_reader gch(stdin);
char_writer wch(stdout);
template<typename T> inline int read(T& t)
{
	bool f=false; int ch; while(ch=gch(),!((ch>='0'&&ch<='9')||ch=='-')) { if(ch==EOF) return 0; }
	t=0;
	if(ch=='-') f=true,ch=gch(); t=ch^48; while(ch=gch(),ch>='0'&&ch<='9') t=(t<<3)+(t<<1)+(ch^48);
	if(f) t=-t;
	return 1;
}
inline int read(char &c)
{
	c=0; int ch; while(ch=gch(),(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')) { if(ch==EOF) return 0; } c=ch;
	return 1;
}
inline int read(char *s)
{
	int ch; while(ch=gch(),(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')) { if(ch==EOF) return 0; }
	*s++=ch; while(ch=gch(),!(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')&&ch!=EOF) *s++=ch;
	return 1;
} inline int read(const char *s) { return read((char*)s); }
inline int readline(char *s)
{
	int ch; while(ch=gch(),(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')) { if(ch==EOF) return 0; }
	*s++=ch; while(ch=gch(),!(ch=='\n'||ch=='\r')&&ch!=EOF) *s++=ch;
	return 1;
} inline int readline(const char *s) { return readline((char*)s); }
template<typename T> inline void write(T t)
{
	int stk[20],cnt=0;
	if(t==0) { wch('0'); return; } if(t<0) { wch('-'); t=-t; }
	while(t>0) { stk[cnt++]=t%10; t/=10; } while(cnt) wch(stk[--cnt]+'0');
}
inline void write(char t) { wch(t); }
inline void write(char *s) { while(*s) wch(*s++); } inline void write(const char *s) { write((char*)s); }
#if __cplusplus >= 201103L
template<typename T,typename... Args> inline int read(T& t,Args&... args) { return read(t)+read(args...); }
template<typename T,typename... Args> inline void write(T t,Args... args) { write(t); write(args...); }
#else
template<typename A_t,typename B_t> inline int read(A_t &a,B_t &b) { return read(a)+read(b); }
template<typename A_t,typename B_t,typename C_t> inline int read(A_t &a,B_t &b,C_t &c) { return read(a)+read(b)+read(c); }
template<typename A_t,typename B_t,typename C_t,typename D_t> inline int read(A_t &a,B_t &b,C_t &c,D_t &d) { return read(a)+read(b)+read(c)+read(d); }
template<typename A_t,typename B_t> inline void write(A_t a,B_t b) { write(a); write(b); }
template<typename A_t,typename B_t,typename C_t> inline void write(A_t a,B_t b,C_t c) { write(a); write(b); write(c); }
template<typename A_t,typename B_t,typename C_t,typename D_t> inline void write(A_t a,B_t b,C_t c,D_t d) { write(a); write(b); write(c); write(d); }
#endif
using namespace std;
typedef long long LL;
const LL mod=998244353;
const int maxn=1e6+10;
int N,M,type,r[maxn];
LL cnt1[2005],cnt2[2005];
LL Factor[maxn*2];
#define Frac(n) (Factor[n])
LL Ksm(LL a,LL b)
{
	LL res=1,x=a;
	while(b)
	{
		if(b&1) res=(res*x)%mod;
		x=(x*x)%mod;
		b>>=1;
	}
	return res;
}
inline LL inv(LL n)
{
	return Ksm(n,mod-2);
}
inline LL Combination(int n,int m)
{
	return (Frac(n)*inv(Frac(m)*Frac(n-m)%mod))%mod;
}
int solve0()
{
	int Blank=M;
	for(int i=1;i<=N;i++) Blank-=2*r[i]-1;
	if(Blank<0) return 0;
	return (Frac(Blank+N)*inv(Frac(Blank)))%mod;
}
int solve1()
{
	assert(N>0);
	if(N==1) return M;
	LL res=0;
	int Blank=M;
	for(int i=1;i<=N;i++) Blank-=2*r[i]-1;
	for(int i=1;i<=N;i++) cnt1[r[i]]++;
	for(int i=2;i<=2000;i++)
		for(int j=1;j<=i-1;j++)
			cnt2[i]=(cnt2[i]+cnt1[j]*cnt1[i-j])%mod;
	for(int i=1;i<=1000;i++) cnt2[i*2]-=cnt1[i];
	// for(int i=1;i<=N;i++)
	// 	for(int j=1;j<=N;j++)
	// 		if(i!=j&&Blank+r[i]+r[j]-2>=0)
	// 			res=(res+Combination(Blank+N+r[i]+r[j]-2,N))%mod;
	for(int i=max(2,2-Blank);i<=2000;i++)
		res=(res+Combination(Blank+N+i-2,N)*cnt2[i])%mod;
	res=(res*Frac(N-2))%mod;
	return res;
}
int main()
{
#ifdef local
	freopen("pro.in","r",stdin);
#endif
	read(N,M,type);
	Factor[0]=1;
	for(int i=1;i<maxn*2;i++) Factor[i]=(Factor[i-1]*i)%mod;
	for(int i=1;i<=N;i++) read(r[i]);
	if(type==0) printf("%d\n",solve0());
	else printf("%d\n",solve1());
	return 0;
}