#include<iostream>
#include<cstring>
#include<algorithm>
#include<cassert>
#include<string>
#include<cstdio>
#include<queue>
#define unlikely(x)     __builtin_expect(!!(x), 0)
struct char_reader
{
        FILE* f; char *buf,*p1,*p2; int size;
        char_reader(FILE* fin,int bufsize=1<<16) { f=fin; size=bufsize; p1=p2=0; buf=new char[size]; }
        ~char_reader() { delete []buf; }
        inline int operator()() { return p1==p2&&(p2=(p1=buf)+fread(buf,1,size,f),p1==p2)?EOF:*p1++; }
};
struct char_writer
{
        FILE* f; char *buf,*p,*end; int size;
        char_writer(FILE* fout,int bufsize=1<<16) { f=fout; size=bufsize; buf=new char[size]; p=buf; end=buf+bufsize; }
        ~char_writer() { fwrite(buf,p-buf,1,f); delete []buf; }
        inline char operator()(char ch)
        {
                if(unlikely(end==p)) { fwrite(buf,end-buf,1,f); p=buf; }
                return *p++=ch;
        }
};
char_reader gch(stdin);
char_writer wch(stdout);
template<typename T> inline int read(T& t)
{
        bool f=false; int ch; while(ch=gch(),!((ch>='0'&&ch<='9')||ch=='-')) { if(ch==EOF) return 0; }
        t=0;
        if(ch=='-') f=true,ch=gch(); t=ch^48; while(ch=gch(),ch>='0'&&ch<='9') t=(t<<3)+(t<<1)+(ch^48);
        if(f) t=-t;
        return 1;
}
inline int read(char &c)
{
        c=0; int ch; while(ch=gch(),(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')) { if(ch==EOF) return 0; } c=ch;
        return 1;
}
inline int read(char *s)
{
        int ch; while(ch=gch(),(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')) { if(ch==EOF) return 0; }
        *s++=ch; while(ch=gch(),!(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')&&ch!=EOF) *s++=ch;
        return 1;
} inline int read(const char *s) { return read((char*)s); }
inline int readline(char *s)
{
        int ch; while(ch=gch(),(ch==' '||ch=='\n'||ch=='\r'||ch=='\t')) { if(ch==EOF) return 0; }
        *s++=ch; while(ch=gch(),!(ch=='\n'||ch=='\r')&&ch!=EOF) *s++=ch;
        return 1;
} inline int readline(const char *s) { return readline((char*)s); }
template<typename T> inline void write(T t)
{
        int stk[20],cnt=0;
        if(t==0) { wch('0'); return; } if(t<0) { wch('-'); t=-t; }
        while(t>0) { stk[cnt++]=t%10; t/=10; } while(cnt) wch(stk[--cnt]+'0');
}
inline void write(char t) { wch(t); }
inline void write(char *s) { while(*s) wch(*s++); } inline void write(const char *s) { write((char*)s); }
#if __cplusplus >= 201103L
template<typename T,typename... Args> inline int read(T& t,Args&... args) { return read(t)+read(args...); }
template<typename T,typename... Args> inline void write(T t,Args... args) { write(t); write(args...); }
#else
template<typename A_t,typename B_t> inline int read(A_t &a,B_t &b) { return read(a)+read(b); }
template<typename A_t,typename B_t,typename C_t> inline int read(A_t &a,B_t &b,C_t &c) { return read(a)+read(b)+read(c); }
template<typename A_t,typename B_t,typename C_t,typename D_t> inline int read(A_t &a,B_t &b,C_t &c,D_t &d) { return read(a)+read(b)+read(c)+read(d); }
template<typename A_t,typename B_t> inline void write(A_t a,B_t b) { write(a); write(b); }
template<typename A_t,typename B_t,typename C_t> inline void write(A_t a,B_t b,C_t c) { write(a); write(b); write(c); }
template<typename A_t,typename B_t,typename C_t,typename D_t> inline void write(A_t a,B_t b,C_t c,D_t d) { write(a); write(b); write(c); write(d); }
#endif
using namespace std;
typedef long long LL;
const int maxn=5e6+10;
const int inf=0x3f3f3f3f;
struct Edge
{
	int v;
	bool deleteable;
	Edge *nxt;
}buf[maxn*2],*G[maxn],*ecnt=buf;
inline void AddEdge(int u,int v)
{
	ecnt->v=v;
	ecnt->nxt=G[u];
	ecnt->deleteable=false;
	G[u]=ecnt++;
}
int n,m,dist[maxn];
int main()
{
#ifdef local
	freopen("pro.in", "r", stdin);
	// freopen("pro.out","w",stdout);
#endif
	read(n,m);
	for(int i=0;i<m;i++)
	{
		int a,b; read(a,b);
		AddEdge(a,b);
		AddEdge(b,a);
	}
	for(int i=1;i<=n;i++) dist[i]=inf;
	dist[1]=0;
	queue<int> Q;
	Q.push(1);
	while(Q.size())
	{
		int u=Q.front(); Q.pop();
		for(Edge *it=G[u];it;it=it->nxt)
			if(dist[u]+1<dist[it->v])
			{
				dist[it->v]=dist[u]+1;
				Q.push(it->v);
			}
	}
	// for(int i=1;i<=n;i++) write("dist ",i," ",dist[i],"\n");
	for(int u=1;u<=n;u++)
	{
		int forward_cnt=0;
		bool have_parallel=false;
		for(Edge *it=G[u];it;it=it->nxt)
		{
			if(dist[u]==dist[it->v]) have_parallel=true;
			if(dist[u]==dist[it->v]+1) forward_cnt++;
			assert(abs(dist[it->v]-dist[u])<=1);
		}
		if(have_parallel||forward_cnt>=2)
		{
			// write(u," ok!\n");
			for(Edge *it=G[u];it;it=it->nxt)
			{
				if(dist[u]==dist[it->v]||dist[u]==dist[it->v]+1)
				{
					it->deleteable=true;
					buf[(it-buf)^1].deleteable=true;
				}
			}
		}
	}
	int res=0;
	for(int i=0;i<m*2;i++) res+=buf[i].deleteable;
	write(res/2,'\n');
	return 0;
}